unit pbmaxmin;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons;

type

  { TpbMaxMinForm }

  TpbMaxMinForm = class(TForm)
    CloseButton: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    procedure CloseButtonClick(Sender: TObject);
    procedure GoButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    BandLabels, HValues, HTimes, LValues, LTimes: array[1..10] of TLabel;
    HGoButtons, LGoButtons: array[1..10] of TSpeedButton;
    HTimeValues, LTimeValues: array[1..10] of TDateTime;
  end;

var
  pbMaxMinForm: TpbMaxMinForm;

implementation

uses main;

{$R *.lfm}
{$R dslstatsbitmaps.res}

{ TpbMaxMinForm }

procedure TpbMaxMinForm.FormCreate(Sender: TObject);
var
  N: Word;
  BMap: TBitmap;
begin
  BMap := TBitmap.Create;
  for N := 1 to 10 do
  begin
    BandLabels[N] := TLabel.Create(Self);
    with BandLabels[N] do
    begin
      Parent := Self;
      Font.Size := 10;
      Font.Style := [fsBold];
      Caption := 'B' + IntToStr(N);
      Autosize := False;
      Height := 22;
      Width := 40;
      Left := 20;
      Top := 35 + (25 * N);
    end;
    HValues[N] := TLabel.Create(Self);
    with HValues[N] do
    begin
      Parent := Self;
      Font.Size := 10;
      Caption := 'HV' + IntToStr(N);
      Left := 70;
      Top := 35 + (25 * N);
    end;
    HTimes[N] := TLabel.Create(Self);
    with HTimes[N] do
    begin
      Parent := Self;
      Font.Size := 10;
      Caption := 'HT' + IntToStr(N);
      Left := 120;
      Top := 35 + (25 * N);
    end;
    LValues[N] := TLabel.Create(Self);
    with LValues[N] do
    begin
      Parent := Self;
      Font.Size := 10;
      Caption := 'LV' + IntToStr(N);
      Left := 340;
      Top := 35 + (25 * N);
    end;
    LTimes[N] := TLabel.Create(Self);
    with LTimes[N] do
    begin
      Parent := Self;
      Font.Size := 10;
      Caption := 'LT' + IntToStr(N);
      Left := 390;
      Top := 35 + (25 * N);
    end;
    HGoButtons[N] := TSpeedButton.Create(Self);
    BMap.LoadFromResourceName(HInstance, 'ARROW');
    with HGoButtons[N] do
    begin
      Parent := Self;
      NumGlyphs := 1;
      Glyph.Assign(BMap);
      Left := 270;
      Top := 32 + (25 * N);
      OnClick := @GoButtonClick;
    end;
    LGoButtons[N] := TSpeedButton.Create(Self);
    with LGoButtons[N] do
    begin
      Parent := Self;
      NumGlyphs := 1;
      Glyph.Assign(BMap);
      Left := 540;
      Top := 32 + (25 * N);
      OnClick := @GoButtonClick;
    end;
  end;
  BMap.Free;
end;

procedure TpbMaxMinForm.CloseButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TpbMaxMinForm.FormDestroy(Sender: TObject);
var
  N: Word;
begin
  for N := 1 to 10 do
  begin
    BandLabels[N].Free;
    HValues[N].Free;
    HTimes[N].Free;
    LValues[N].Free;
    LTimes[N].Free;
    HGoButtons[N].Free;
    LGoButtons[N].Free;
  end;
end;

procedure TpbMaxMinForm.GoButtonClick(Sender: TObject);
var
  N: Byte;
  T: TDateTime;
begin
  for N := 0 to 4 do
  if Sender = HGoButtons[N] then
  begin
    T := HTimeValues[N];
    Break;
  end
  else if Sender = LGoButtons[N] then
  begin
    T := LTimeValues[N];
    Break;
  end;
  Mainform.GototimePB(T);
  Close;
end;

end.

