unit tonerange;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons;

type

  { TToneRangeForm }

  TToneRangeForm = class(TForm)
    CustomButton: TRadioButton;
    RangeCloseButton: TBitBtn;
    Label1: TLabel;
    Label142: TLabel;
    Label144: TLabel;
    ADSLButton: TRadioButton;
    ADSL2plusButton: TRadioButton;
    VDSL2Button: TRadioButton;
    TonesperpxEdit: TScrollBar;
    procedure ADSLButtonChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure RangeCloseButtonClick(Sender: TObject);
    procedure TonesperpxEditChange(Sender: TObject);
  private
    { private declarations }
    ButtonPressed: Boolean;
  public
    { public declarations }
    RangeSetting: SmallInt;
    Passive: Boolean;
  end;

var
  ToneRangeForm: TToneRangeForm;

implementation

uses main;

{$R *.lfm}

{ TToneRangeForm }

procedure TToneRangeForm.FormCreate(Sender: TObject);
begin
  RangeSetting := -1;
  Passive := True;
end;

procedure TToneRangeForm.RangeCloseButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TToneRangeForm.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin
  Passive := True;
end;

procedure TToneRangeForm.TonesperpxEditChange(Sender: TObject);
begin
  if Passive then Exit;
  RangeSetting := TonesperpxEdit.Position;
  Mainform.Tonesperpx(RangeSetting);
  if ButtonPressed then ButtonPressed := False
  else CustomButton.Checked := True;
end;

procedure TToneRangeForm.ADSLButtonChange(Sender: TObject);
begin
  if Passive then Exit;
  if Sender = ADSLButton then RangeSetting := 1
  else if Sender = ADSL2plusButton then RangeSetting := -1
  else RangeSetting := -7;
  ButtonPressed := True;
  TonesperpxEdit.Position := RangeSetting;
end;

end.

